#ifndef NAMES_CPP
#define NAMES_CPP

#include "basedef.h"
#include "error.h"
#include <iostream.h>
#include <alloc.h>
#include <string.h>

class Names {
	char** nstr; // an array of strings (item names).
	const int a_size; // size of array.
	int add_pos;
	public:
		Names(int sz) : a_size(sz),nstr(new char*[sz]),add_pos(0) {}
		err_c load_str(istream& in);
		long store_str(ostream& out);
		void add_name(char* str) {nstr[add_pos++]=str;}
		char* get_name(int k) {return nstr[k];}
		int max_len(); // returns the maximum name length (<=40).
		~Names();
};

err_c Names::load_str(istream& in) {
	for (int add_pos=0;add_pos<a_size;add_pos++) {
		nstr[add_pos]=(char*)malloc(max_name_len);
		if (nstr[add_pos]==NULL) return OUT_OF_MEMORY;
		in.get(nstr[add_pos],max_name_len,'\0');
		nstr[add_pos]=(char*)realloc(nstr[add_pos],in.gcount()+2);
		if (in.eof() || in.get()!='\0') return LOAD_STR_FAILED;
	}
	return NO_ERROR;
}

long Names::store_str(ostream& out) {
	long start=out.tellp();
	for (int i=0;i<a_size;i++)
		out.write(nstr[i],strlen(nstr[i])+1);
	return out.tellp()-start;
}

Names::~Names() {
	for (int i=0;i<add_pos;i++)
		free(nstr[i]);
	delete nstr;
}

int Names::max_len() {
	int max=0;
	int buf;
	for (int i=0;i<a_size;i++)
		if ((buf=strlen(nstr[i]))>max)
			max=buf;
	return max<40 ? max : 40;
}

#endif